#!/bin/sh

# Copyright 2019 Paul Hänsch
#
# This file is part of Confetti.
# 
# Confetti is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# 
# Confetti is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
# 
# You should have received a copy of the GNU Affero General Public License
# along with Confetti.  If not, see <http://www.gnu.org/licenses/>. 

locktimeout=900
. "$_EXEC"/session_lock.sh

card="$(GET card |PATH)"
cardfile="$_DATA/vcard/${card##*/}"
filter="$(REF f)"
order="$(REF o)"

if tempfile="$(SLOCK "$cardfile" "$locktimeout")"; then
  REDIRECT "/cards/?o=${order}&f=${filter}&e=${card}"
elif [ -f "$tempfile" ]; then
  SET_COOKIE session message="SESSLOCK"
  REDIRECT "/cards/?o=${order}&f=${filter}#${card}"
else
  SET_COOKIE session message="EDITLOCK"
  REDIRECT "/cards/?o=${order}&f=${filter}#${card}"
fi
